#ifndef GGAFLIB_LINEAROCTREEFORACTOR_H_
#define GGAFLIB_LINEAROCTREEFORACTOR_H_
#include "GgafLibCommonHeader.h"
#include "jp/ggaf/core/util/GgafLinearOctree.h"

namespace GgafLib {

#define MAX_COLLISIONSTACK_ACTOR_NUM (2000)
/**
 * GgafActorvfƂ蔻@\ǉ`ؔzNX .
 * AO[v  BO[v2O[vԂ̓蔻s
 * @version 1.00
 * @since 2009/11/23
 * @author Masatoshi Tsuge
 */
class LinearOctreeForActor : public GgafCore::GgafLinearOctree {

    uint32_t _num_space_minus_one;

public:
    /**
     * 蔻AN^[ێX^bN .
     * ̎lĂȂ댯ȃX^bN
     */
    class CollisionStack {
    public:
        /** [r]̋ԂɃX^bNAN^[̔zBgp̂[0]`[MAX_COLLISIONSTACK_ACTOR_NUM-1]B+1́AŌ̗vfԕɂĂ */
        GgafCore::GgafObject* _apObject[MAX_COLLISIONSTACK_ACTOR_NUM+1]; //Ō̗vf(+1)͔ԕ
        /** [r]J[\|C^(PUSHovfwĂ)  */
        GgafCore::GgafObject** _papCur;
        /** [r]ɃX^bN̐擪vfwĂ */
        GgafCore::GgafObject** _papFirst;
        /** [r]ɃX^bN̍Ō̗vf̎wĂ */
        GgafCore::GgafObject** _papBanpei;
    public:
        /**
         * RXgN^
         * @return
         */
        CollisionStack() {
            _papFirst = &_apObject[0];
            _papBanpei = &_apObject[MAX_COLLISIONSTACK_ACTOR_NUM];
            _papCur = _papFirst;
        }
        /**
         * X^bNɐς .
         * @param prm_pActor ςރAN^[
         */
        inline void push(GgafCore::GgafObject* prm_pObject) {
            if (_papCur == _papBanpei) {
                _TRACE_("x LinearOctreeForActor::push("<<prm_pObject<<") X^bNg؂܂B܂Bӏɓ蔻肪߂łB");
                return;
            }
            (*_papCur) = prm_pObject;
            ++_papCur;
        }

        /**
         * X^bNo .
         * @return oꂽAN^[
         */
        inline GgafCore::GgafObject* pop() {
            if (_papCur == _papFirst) {
                return nullptr;
            } else {
                --_papCur;
                return (*_papCur);
            }
        }

        inline bool isExist() {
            return _papCur == _papFirst ? false : true;
        }

        /**
         * ̃X^bNSĎo(pop)Ao莩g̃X^bNɐς(push) .
         * ̃X^bŃAKɂȂB
         * @param prm_pCollisionStack
         */
        inline void popush(CollisionStack* prm_pCollisionStack) {
            if (_papCur == _papBanpei) {
                _TRACE_("x LinearOctreeForActor::popush("<<prm_pCollisionStack<<") X^bNg؂Ă܂B܂Bӏɓ蔻肪߂łB");
                prm_pCollisionStack->clear();
                return;
            }
            while ((*_papCur) = prm_pCollisionStack->pop()) { //BpopoȂ nullptrB I know "=" , not "=="
                 ++_papCur;
                 if (_papCur == _papBanpei) {
                    _TRACE_("x LinearOctreeForActor::popush("<<prm_pCollisionStack<<") X^bNg؂܂B܂Bӏɓ蔻肪߂łB");
                    prm_pCollisionStack->clear();
                    break;
                }
            }
        }
        /**
         * ς񂾃X^bNȂɂB .
         */
        inline void clear() {
            _papCur = _papFirst;
        }
        ~CollisionStack() {
            clear();
        }
    };

    /** [r]SԂ̓蔻莞A݂̋ԂɏAN^[AO[ṽX^bN */
    CollisionStack _stackGroupA_Current;
    /** [r]SԂ̓蔻莞A݂̋ԂɏAN^[BO[ṽX^bN */
    CollisionStack _stackGroupB_Current;
    /** [r]Ԃ̓蔻莞AeԂɏSAN^[AO[ṽX^bN */
    CollisionStack _stackGroupA;
    /** [r]Ԃ̓蔻莞AeԂɏSAN^[BO[ṽX^bN */
    CollisionStack _stackGroupB;

    /** [r]񓖂蔻sAN^[A */
    actorkind _kind_groupA;
    /** [r]񓖂蔻sAN^[B */
    actorkind _kind_groupB;

public:
    /**
     * RXgN^
     * @param prm_level 쐬锪؋ԃx
     */
    explicit LinearOctreeForActor(int prm_level);

    /**
     * ؏́uAN^[AO[v  AN^[BO[vvs  .
     * Av͖{\bhĂԂł悢B<BR>
     *  executeAllHitChk  processJudgement() ŌĂԕKvB<BR>
     * @param prm_groupA AN^[AO[v
     * @param prm_groupB AN^[BO[v
     */
    void executeAllHitChk(actorkind prm_groupA, actorkind prm_groupB);

    /**
     * ̋Ԃ̓蔻s  .
     * executeAllHitChk gpB
     * @param prm_index `ؔz̔zvfԍ
     */
    void executeHitChk(uint32_t prm_index);

    /**
     * AN^[AO[ṽX^bNƁAAN^[BO[ṽX^bN̑̓蔻s  .
     * executeHitChk gpB
     * @param prm_pStackA AN^[AO[ṽX^bN
     * @param prm_pStackB AN^[BO[ṽX^bN
     */
    void executeHitChk_RoundRobin(CollisionStack* prm_pStackA, CollisionStack* prm_pStackB);

    virtual ~LinearOctreeForActor();
};


}
#endif /*GGAFLIB_LINEAROCTREEFORACTOR_H_*/

