#include "jp/ggaf/lib/util/LinearOctreeForActor.h"

#include "jp/ggaf/core/util/GgafLinearOctreeOctant.h"
#include "jp/ggaf/core/util/GgafLinearOctreeElem.h"
#include "jp/ggaf/core/actor/GgafActor.h"

using namespace GgafCore;
using namespace GgafDxCore;
using namespace GgafLib;

LinearOctreeForActor::LinearOctreeForActor(int prm_level) : GgafLinearOctree(prm_level) {
    _num_space_minus_one = _num_space-1;
    _kind_groupA = 0;
    _kind_groupB = 0;
}

void LinearOctreeForActor::executeAllHitChk(actorkind prm_groupA, actorkind prm_groupB) {
    _kind_groupA = prm_groupA;
    _kind_groupB = prm_groupB;
    if ( (_paOctant[0]._kindinfobit & _kind_groupA) && (_paOctant[0]._kindinfobit & _kind_groupB) ) {
        //ł͔؂闷֍sĂႢ
        executeHitChk(0); //Ă܂
        //͂AȂB
        _stackGroupA.clear();
        _stackGroupB.clear();
    }
}

void LinearOctreeForActor::executeHitChk(uint32_t prm_index) {
    GgafLinearOctreeOctant* pOctant_this_level = &(_paOctant[prm_index]);
    GgafLinearOctreeElem* pElem = pOctant_this_level->_pElem_first;
    const uint32_t kind_groupA = _kind_groupA;
    const uint32_t kind_groupB = _kind_groupB;
    if (pElem) {
        GgafLinearOctreeElem* pElem_last = pOctant_this_level->_pElem_last;
        while (true) {
            if (pElem->_kindbit & kind_groupA) {
                _stackGroupA_Current.push(pElem->_pObject);
            }
            if (pElem->_kindbit & kind_groupB) {
                _stackGroupB_Current.push(pElem->_pObject);
            }
            if (pElem == pElem_last) {
                break;
            }
            pElem = pElem->_pNext;
        }
        //݂̋Ԃ̃O[vAƃO[vB
        executeHitChk_RoundRobin(&_stackGroupA_Current, &_stackGroupB_Current);
        //݂̋Ԃ̃O[vAƐeԏ̃O[vB
        executeHitChk_RoundRobin(&_stackGroupA_Current, &_stackGroupB );
        //eԏ̃O[vAƌ݂̋Ԃ̃O[vB
        executeHitChk_RoundRobin(&_stackGroupA , &_stackGroupB_Current);
    }

    const uint32_t lower_level_index = prm_index*8 + 1; //_papOctant[prm_index] Ԃ̎qԂ̃[gʒu0Ԃ̔zvfԍ
    if ( lower_level_index > _num_space_minus_one) {
        //vfI[o[A܂胊[t
        _stackGroupA_Current.clear();
        _stackGroupB_Current.clear();
        return; //eԂ֖߂
    } else {

        //BȂOɌԃAN^[eԃAN^[̃X^bN֒ǉB
        //Ԃ猩ꍇ̐eԃAN^[݌vĂĂB
        //(ɌԃX^bNJ)
        GgafObject** temp_stackGroupA = _stackGroupA._papCur; //X^bN|C^ۑ(̃ZbgɎgp)
        GgafObject** temp_stackGroupB = _stackGroupB._papCur; //X^bN|C^ۑ(̃ZbgɎgp)
        _stackGroupA.popush(&_stackGroupA_Current); //Current  Parent ɒǉBCurrent̓NAB
        _stackGroupB.popush(&_stackGroupB_Current); //Current  Parent ɒǉBCurrent̓NAB
        bool isExistGroupA = _stackGroupA.isExist();
        bool isExistGroupB = _stackGroupB.isExist();

        //qbg`FbNsɁAq(W)֐ɍs`B
        //̃x̋ԂɎABo^ĂΐB
        //́Ãx̋ԂɎAAXgbNɎBΐB
        //́Ãx̋ԂɎBAXgbNɎAΐB
        //ȊO͐Ȃ
        GgafLinearOctreeOctant* pOctant_lower_level = &(_paOctant[lower_level_index]);
        uint32_t kindinfobit_lower_level = pOctant_lower_level->_kindinfobit;
        if (kindinfobit_lower_level & kind_groupA) {
            if (isExistGroupB || (kindinfobit_lower_level & kind_groupB)) {
                executeHitChk(lower_level_index);
            }
        } else if (kindinfobit_lower_level & kind_groupB) {
            if (isExistGroupA) {
                executeHitChk(lower_level_index);
            }
        }

        kindinfobit_lower_level = (++pOctant_lower_level)->_kindinfobit;
        if (kindinfobit_lower_level & kind_groupA) {
            if (isExistGroupB || (kindinfobit_lower_level & kind_groupB)) {
                executeHitChk(lower_level_index+1);
            }
        } else if (kindinfobit_lower_level & kind_groupB) {
            if (isExistGroupA) {
                executeHitChk(lower_level_index+1);
            }
        }

        kindinfobit_lower_level = (++pOctant_lower_level)->_kindinfobit;
        if (kindinfobit_lower_level & kind_groupA) {
            if (isExistGroupB || (kindinfobit_lower_level & kind_groupB)) {
                executeHitChk(lower_level_index+2);
            }
        } else if (kindinfobit_lower_level & kind_groupB) {
            if (isExistGroupA) {
                executeHitChk(lower_level_index+2);
            }
        }

        kindinfobit_lower_level = (++pOctant_lower_level)->_kindinfobit;
        if (kindinfobit_lower_level & kind_groupA) {
            if (isExistGroupB || (kindinfobit_lower_level & kind_groupB)) {
                executeHitChk(lower_level_index+3);
            }
        } else if (kindinfobit_lower_level & kind_groupB) {
            if (isExistGroupA) {
                executeHitChk(lower_level_index+3);
            }
        }

        kindinfobit_lower_level = (++pOctant_lower_level)->_kindinfobit;
        if (kindinfobit_lower_level & kind_groupA) {
            if (isExistGroupB || (kindinfobit_lower_level & kind_groupB)) {
                executeHitChk(lower_level_index+4);
            }
        } else if (kindinfobit_lower_level & kind_groupB) {
            if (isExistGroupA) {
                executeHitChk(lower_level_index+4);
            }
        }

        kindinfobit_lower_level = (++pOctant_lower_level)->_kindinfobit;
        if (kindinfobit_lower_level & kind_groupA) {
            if (isExistGroupB || (kindinfobit_lower_level & kind_groupB)) {
                executeHitChk(lower_level_index+5);
            }
        } else if (kindinfobit_lower_level & kind_groupB) {
            if (isExistGroupA) {
                executeHitChk(lower_level_index+5);
            }
        }

        kindinfobit_lower_level = (++pOctant_lower_level)->_kindinfobit;
        if (kindinfobit_lower_level & kind_groupA) {
            if (isExistGroupB || (kindinfobit_lower_level & kind_groupB)) {
                executeHitChk(lower_level_index+6);
            }
        } else if (kindinfobit_lower_level & kind_groupB) {
            if (isExistGroupA) {
                executeHitChk(lower_level_index+6);
            }
        }

        kindinfobit_lower_level = (++pOctant_lower_level)->_kindinfobit;
        if (kindinfobit_lower_level & kind_groupA) {
            if (isExistGroupB || (kindinfobit_lower_level & kind_groupB)) {
                executeHitChk(lower_level_index+7);
            }
        } else if (kindinfobit_lower_level & kind_groupB) {
            if (isExistGroupA) {
                executeHitChk(lower_level_index+7);
            }
        }

//        //AȂ
//        //X^bN̉ipushAɖ߂j
        _stackGroupA._papCur = temp_stackGroupA;
        _stackGroupB._papCur = temp_stackGroupB;
        return; //eԂ֖߂
    }
}

void LinearOctreeForActor::executeHitChk_RoundRobin(CollisionStack* prm_pStackA, CollisionStack* prm_pStackB) {
    //LinearOctreeForActorł́Avf̎w(GgafObject*)CX^X GgafActorO
    if (prm_pStackA->isExist() && prm_pStackB->isExist()) {
        GgafObject** papStackActor_A_Cur = prm_pStackA->_papCur;
        GgafObject** papStackActor_B_Cur = prm_pStackB->_papCur;
        GgafObject** papStackActor_A = prm_pStackA->_papFirst;
        while (papStackActor_A != papStackActor_A_Cur) {
            GgafObject** papStackActor_B = prm_pStackB->_papFirst;
            while (papStackActor_B != papStackActor_B_Cur) {
                ((GgafActor*)(*papStackActor_A))->executeHitChk_MeAnd((GgafActor*)(*papStackActor_B));
                ++papStackActor_B;
            }
            ++papStackActor_A;
        }
    }
}

LinearOctreeForActor::~LinearOctreeForActor() {
}

