#ifndef MENUBOARD_H_
#define MENUBOARD_H_
#include "VioletVreath.h"
#include "jp/ggaf/lib/actor/menu/MenuActor.hpp"

namespace VioletVreath {

/**
 * {Aṽj[{[hW .
 * XCh̃gWVB
 * LZ̎B
 * @version 1.00
 * @since 2011/12/26
 * @author Masatoshi Tsuge
 */
class MenuBoard : public GgafLib::FontBoardMenu {

public:
    enum {
        SE_ON_RISEN      ,
        SE_MOVE_CURSOR   ,
        SE_DECIDED_OK    ,
        SE_DECIDED_CANCEL,
        SE_WRONG         ,
    };

    coord slide_from_offset_x_;
    coord slide_from_offset_y_;
    coord target_x_;
    coord target_y_;

public:
    MenuBoard(const char* prm_name, const char* prm_model);

    /**
     * j[\̃XChgWV̐ݒ .
     * @param prm_menu_fade_frames j[̃tF[hCiƃtF[hAEgj̃t[
     * @param prm_slide_from_offset_x j[̃XChJn̑XW
     * @param prm_slide_from_offset_y j[̃XChJn̑XW
     */
    void setTransition(frame prm_menu_fade_frames,
                       coord prm_slide_from_offset_x, coord prm_slide_from_offset_y);

    virtual bool condDecision() override;
    virtual bool condCancel() override;
    virtual bool condSelectNext() override;
    virtual bool condSelectPrev() override;
    virtual bool condSelectExNext() override;
    virtual bool condSelectExPrev() override;
    virtual bool condSelectCancel() override;
    virtual void moveCursor(bool prm_smooth = true) override;
    virtual void onMoveCursor(int prm_from, int prm_to) override;
    virtual void onSelect(int prm_from, int prm_to) override;

    virtual void initialize() override;

    /**
     * \ʒu݂_x, _yŐݒ肵j[(g)N .
     * ʏ͑̃IuWFNgĂяo郁\bhłB
     */
    virtual void riseMe() override;

    /**
     * \ʒuw肵ăj[(g)N .
     * W̓XChėWwB
     * ʏ͑̃IuWFNgĂяo郁\bhłB
     * @param prm_target_x \XW
     * @param prm_target_y \YW
     */
    virtual void rise(coord prm_target_x, coord prm_target_y);

    /**
     * \ʒuw肵ăTuj[N .
     * W̓Tuj[XChėWwB
     * ( void MenuActor<T>::riseSubMenu(int prm_index) B)
     * @param prm_index Tuj[CfbNX(ǉԁB0`)
     * @param prm_target_x Tuj[\XW
     * @param prm_target_y Tuj[\YW
     */
    virtual void riseSubMenu(int prm_index, coord prm_target_x, coord prm_target_y);
    virtual void riseSubMenu(coord prm_target_x, coord prm_target_y);
    virtual void onRise() override;
    virtual void processBehavior() override;
    virtual void processJudgement() override;
    virtual void onSink() override;

    virtual ~MenuBoard();
};

}
#endif /*MENUBOARD_H_*/

